<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>react-cheat-sheet</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="react.js-cheatsheet">React.js cheatsheet</h1>
    <blockquote>
      <p>
        React.Component · render() · componentDidMount() · props/state ·
        dangerouslySetInnerHTML · React is a JavaScript library for building
        user interfaces. This guide targets React v15 to v16.
      </p>
    </blockquote>
    <p>
      <a href="https://reactjs.org/">React</a> is a JavaScript library for
      building user interfaces. This guide targets React v15 to v16.
    </p>
    <h1 id="react-cheat-sheet">React Cheat Sheet</h1>
    <h2 id="render">render</h2>
    <pre><code>render() {
  return &lt;div /&gt;;
}</code></pre>
    <h2 id="constructor">constructor</h2>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1">    <span class="at">constructor</span>(props) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">      <span class="kw">super</span>(props)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-3" title="3">      <span class="kw">this</span>.<span class="at">state</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-4" title="4">        <span class="dt">list</span><span class="op">:</span> <span class="va">props</span>.<span class="at">initialList</span></a>
<a class="sourceLine" id="cb2-5" title="5">      <span class="op">};</span></a>
<a class="sourceLine" id="cb2-6" title="6">    <span class="op">}</span></a>
<a class="sourceLine" id="cb2-7" title="7"></a>
<a class="sourceLine" id="cb2-8" title="8">    <span class="co">// where props aren&#39;t used in constructor</span></a>
<a class="sourceLine" id="cb2-9" title="9"></a>
<a class="sourceLine" id="cb2-10" title="10">    <span class="at">constructor</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb2-11" title="11">      <span class="kw">super</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb2-12" title="12">      <span class="kw">this</span>.<span class="at">state</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-13" title="13">        <span class="dt">list</span><span class="op">:</span> []</a>
<a class="sourceLine" id="cb2-14" title="14">      <span class="op">};</span></a>
<a class="sourceLine" id="cb2-15" title="15">    <span class="op">}</span></a></code></pre>
    </div>
    <h2 id="componentwillmount">componentWillMount</h2>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1">    <span class="at">componentWillMount</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb3-2" title="2">      <span class="co">// invoked once.</span></a>
<a class="sourceLine" id="cb3-3" title="3">      <span class="co">// fires before initial &#39;render&#39;</span></a>
<a class="sourceLine" id="cb3-4" title="4">    <span class="op">}</span></a></code></pre>
    </div>
    <h2 id="componentdidmount">componentDidMount</h2>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1">    <span class="at">componentDidMount</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">      <span class="co">// good for AJAX: fetch, ajax, or subscriptions.</span></a>
<a class="sourceLine" id="cb4-3" title="3"></a>
<a class="sourceLine" id="cb4-4" title="4">      <span class="co">// invoked once (client-side only).</span></a>
<a class="sourceLine" id="cb4-5" title="5">      <span class="co">// fires before initial &#39;render&#39;</span></a>
<a class="sourceLine" id="cb4-6" title="6">    <span class="op">}</span></a></code></pre>
    </div>
    <h2 id="componentwillreceiveprops">componentWillReceiveProps</h2>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1">    <span class="at">componentWillReceiveProps</span>(nextProps) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">      <span class="co">// invoked every time component recieves new props.</span></a>
<a class="sourceLine" id="cb5-3" title="3">      <span class="co">// does not before initial &#39;render&#39;</span></a>
<a class="sourceLine" id="cb5-4" title="4">    <span class="op">}</span></a></code></pre>
    </div>
    <h2 id="shouldcomponentupdate">shouldComponentUpdate</h2>
    <div class="sourceCode" id="cb6">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb6-1" title="1">    <span class="at">shouldComponentUpdate</span>(nextProps<span class="op">,</span> nextState) <span class="op">{</span></a>
<a class="sourceLine" id="cb6-2" title="2">      <span class="co">// invoked before every update (new props or state).</span></a>
<a class="sourceLine" id="cb6-3" title="3">      <span class="co">// does not fire before initial &#39;render&#39;.</span></a>
<a class="sourceLine" id="cb6-4" title="4">    <span class="op">}</span></a></code></pre>
    </div>
    <h2 id="componentwillupdate">componentWillUpdate</h2>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1">    <span class="at">componentWillUpdate</span>(nextProps<span class="op">,</span> nextState) <span class="op">{</span></a>
<a class="sourceLine" id="cb7-2" title="2">      <span class="co">// invoked immediately before update (new props or state).</span></a>
<a class="sourceLine" id="cb7-3" title="3">      <span class="co">// does not fire before initial &#39;render&#39;.</span></a>
<a class="sourceLine" id="cb7-4" title="4"></a>
<a class="sourceLine" id="cb7-5" title="5">      <span class="co">// (see componentWillReceiveProps if you need to call setState)</span></a>
<a class="sourceLine" id="cb7-6" title="6">    <span class="op">}</span></a></code></pre>
    </div>
    <p><strong>✖ this.setState</strong></p>
    <h2 id="componentdidupdate">componentDidUpdate</h2>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1">    <span class="at">componentDidUpdate</span>(prevProps<span class="op">,</span> prevState) <span class="op">{</span></a>
<a class="sourceLine" id="cb8-2" title="2">      <span class="co">// invoked immediately after DOM updates</span></a>
<a class="sourceLine" id="cb8-3" title="3">      <span class="co">// does not fire after initial &#39;render&#39;</span></a>
<a class="sourceLine" id="cb8-4" title="4">    <span class="op">}</span></a></code></pre>
    </div>
    <h2 id="componentwillunmount">componentWillUnmount</h2>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1">    <span class="at">componentWillUnmount</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb9-2" title="2">      <span class="co">// invoked immediately before a component is unmounted.</span></a>
<a class="sourceLine" id="cb9-3" title="3">    <span class="op">}</span></a></code></pre>
    </div>
    <h2 id="setstate-function">setState (function)</h2>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="co">// good for state transitions</span></a>
<a class="sourceLine" id="cb10-2" title="2"></a>
<a class="sourceLine" id="cb10-3" title="3"><span class="kw">this</span>.<span class="at">setState</span>((prevState<span class="op">,</span> props) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb10-4" title="4">  <span class="cf">return</span> <span class="op">{</span> <span class="dt">count</span><span class="op">:</span> <span class="va">prevState</span>.<span class="at">count</span> <span class="op">+</span> <span class="va">props</span>.<span class="at">step</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb10-5" title="5"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="setstate-object">setState (object)</h2>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1">    <span class="co">// good for static values</span></a>
<a class="sourceLine" id="cb11-2" title="2"></a>
<a class="sourceLine" id="cb11-3" title="3">    <span class="kw">this</span>.<span class="at">setState</span>(<span class="op">{</span><span class="dt">mykey</span><span class="op">:</span> <span class="st">&#39;my new value&#39;</span><span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb11-4" title="4"></a>
<a class="sourceLine" id="cb11-5" title="5">    <span class="vs">```</span></a>
<a class="sourceLine" id="cb11-6" title="6"></a>
<a class="sourceLine" id="cb11-7" title="7"><span class="vs">setState (optional callback)</span></a>
<a class="sourceLine" id="cb11-8" title="8"><span class="vs">----------------------------</span></a>
<a class="sourceLine" id="cb11-9" title="9"><span class="vs">```</span>js</a>
<a class="sourceLine" id="cb11-10" title="10">    <span class="co">// fires after setState</span></a>
<a class="sourceLine" id="cb11-11" title="11">    <span class="co">// prefer componentDidUpdate</span></a>
<a class="sourceLine" id="cb11-12" title="12"></a>
<a class="sourceLine" id="cb11-13" title="13">    <span class="kw">this</span>.<span class="at">setState</span>(</a>
<a class="sourceLine" id="cb11-14" title="14">      (prevState<span class="op">,</span> props) <span class="kw">=&gt;</span> (<span class="op">{</span> <span class="dt">count</span><span class="op">:</span> <span class="va">prevState</span>.<span class="at">count</span> <span class="op">+</span> <span class="va">props</span>.<span class="at">step</span> <span class="op">}</span>)<span class="op">,</span></a>
<a class="sourceLine" id="cb11-15" title="15">      () <span class="kw">=&gt;</span> <span class="va">console</span>.<span class="at">log</span>(<span class="kw">this</span>.<span class="va">state</span>.<span class="at">count</span>)</a>
<a class="sourceLine" id="cb11-16" title="16">    )<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="forceupdate">forceUpdate</h2>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="co">// forces a re-render; AVOID if possible</span></a>
<a class="sourceLine" id="cb12-2" title="2"></a>
<a class="sourceLine" id="cb12-3" title="3"><span class="kw">this</span>.<span class="at">forceUpdate</span>()<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="displayname">displayName</h2>
    <div class="sourceCode" id="cb13">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb13-1" title="1">    displayName<span class="op">:</span> <span class="st">&quot;MyComponent&quot;</span></a>
<a class="sourceLine" id="cb13-2" title="2"></a>
<a class="sourceLine" id="cb13-3" title="3"></a>
<a class="sourceLine" id="cb13-4" title="4">    <span class="vs">```</span></a>
<a class="sourceLine" id="cb13-5" title="5"></a>
<a class="sourceLine" id="cb13-6" title="6"><span class="vs">defaultProps</span></a>
<a class="sourceLine" id="cb13-7" title="7"><span class="vs">------------</span></a>
<a class="sourceLine" id="cb13-8" title="8"><span class="vs">```</span>js</a>
<a class="sourceLine" id="cb13-9" title="9">    <span class="kw">class</span> Greeting <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb13-10" title="10">          <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb13-11" title="11">            <span class="cf">return</span> <span class="op">&lt;</span>h1<span class="op">&gt;</span>Hi <span class="op">{</span><span class="kw">this</span>.<span class="va">props</span>.<span class="at">name</span><span class="op">}</span>&lt;/h1<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb13-12" title="12">          <span class="op">}</span></a>
<a class="sourceLine" id="cb13-13" title="13">        <span class="op">}</span></a>
<a class="sourceLine" id="cb13-14" title="14"></a>
<a class="sourceLine" id="cb13-15" title="15">        <span class="va">CustomButton</span>.<span class="at">defaultProps</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb13-16" title="16">          <span class="dt">name</span><span class="op">:</span> <span class="st">&#39;guest&#39;</span></a>
<a class="sourceLine" id="cb13-17" title="17">        <span class="op">};</span></a></code></pre>
    </div>
    <h2 id="children.map">Children.map</h2>
    <div class="sourceCode" id="cb14">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb14-1" title="1"><span class="va">React</span>.<span class="va">Children</span>.<span class="at">map</span>(<span class="kw">this</span>.<span class="va">props</span>.<span class="at">children</span><span class="op">,</span> (child<span class="op">,</span> i) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb14-2" title="2">  <span class="cf">return</span> child<span class="op">;</span></a>
<a class="sourceLine" id="cb14-3" title="3"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="children.foreach">Children.forEach</h2>
    <div class="sourceCode" id="cb15">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb15-1" title="1"><span class="va">React</span>.<span class="va">Children</span>.<span class="at">forEach</span>(<span class="kw">this</span>.<span class="va">props</span>.<span class="at">children</span><span class="op">,</span> (child<span class="op">,</span> i) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb15-2" title="2">  <span class="va">console</span>.<span class="at">log</span>(child <span class="op">+</span> <span class="st">&quot; at index: &quot;</span> <span class="op">+</span> i)<span class="op">;</span></a>
<a class="sourceLine" id="cb15-3" title="3"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="children.count">Children.count</h2>
    <div class="sourceCode" id="cb16">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb16-1" title="1"><span class="va">React</span>.<span class="va">Children</span>.<span class="at">count</span>(<span class="kw">this</span>.<span class="va">props</span>.<span class="at">children</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="children.only">Children.only</h2>
    <div class="sourceCode" id="cb17">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb17-1" title="1"><span class="va">React</span>.<span class="va">Children</span>.<span class="at">only</span>(<span class="kw">this</span>.<span class="va">props</span>.<span class="at">children</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="children.toarray">Children.toArray</h2>
    <div class="sourceCode" id="cb18">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb18-1" title="1"><span class="va">React</span>.<span class="va">Children</span>.<span class="at">toArray</span>(<span class="kw">this</span>.<span class="va">props</span>.<span class="at">children</span>)<span class="op">;</span></a></code></pre>
    </div>
    <h2 id="context-example">Context (example)</h2>
    <div class="sourceCode" id="cb19">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb19-1" title="1"><span class="co">// requires &#39;prop-types&#39; library</span></a>
<a class="sourceLine" id="cb19-2" title="2"></a>
<a class="sourceLine" id="cb19-3" title="3"><span class="im">import</span> <span class="op">{</span> string <span class="op">}</span> <span class="im">from</span> <span class="st">&quot;prop-types&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb19-4" title="4"></a>
<a class="sourceLine" id="cb19-5" title="5"><span class="kw">class</span> Cowboy <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb19-6" title="6">  <span class="dt">childContextTypes</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb19-7" title="7">    <span class="dt">salutation</span><span class="op">:</span> string<span class="op">,</span></a>
<a class="sourceLine" id="cb19-8" title="8">  <span class="op">};</span></a>
<a class="sourceLine" id="cb19-9" title="9"></a>
<a class="sourceLine" id="cb19-10" title="10">  <span class="at">getChildContext</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb19-11" title="11">    <span class="cf">return</span> <span class="op">{</span> <span class="dt">salutation</span><span class="op">:</span> <span class="st">&quot;Howdy&quot;</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb19-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb19-13" title="13"></a>
<a class="sourceLine" id="cb19-14" title="14">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb19-15" title="15">    <span class="cf">return</span> <span class="va">React</span>.<span class="va">Children</span>.<span class="at">only</span>(<span class="kw">this</span>.<span class="va">props</span>.<span class="at">children</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb19-16" title="16">  <span class="op">}</span></a>
<a class="sourceLine" id="cb19-17" title="17"><span class="op">}</span></a>
<a class="sourceLine" id="cb19-18" title="18"></a>
<a class="sourceLine" id="cb19-19" title="19"><span class="kw">const</span> Greeting <span class="op">=</span> (props<span class="op">,</span> context) <span class="kw">=&gt;</span> (</a>
<a class="sourceLine" id="cb19-20" title="20">  <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb19-21" title="21">    <span class="op">{</span><span class="va">context</span>.<span class="at">salutation</span><span class="op">}</span> <span class="op">{</span><span class="va">props</span>.<span class="at">name</span><span class="op">}</span>.</a>
<a class="sourceLine" id="cb19-22" title="22">  &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb19-23" title="23">)<span class="op">;</span></a>
<a class="sourceLine" id="cb19-24" title="24"></a>
<a class="sourceLine" id="cb19-25" title="25"><span class="va">Greeting</span>.<span class="at">contextTypes</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb19-26" title="26">  <span class="dt">salutation</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">string</span><span class="op">,</span></a>
<a class="sourceLine" id="cb19-27" title="27"><span class="op">};</span></a>
<a class="sourceLine" id="cb19-28" title="28"></a>
<a class="sourceLine" id="cb19-29" title="29"><span class="co">// &lt;Greeting name=&quot;Michael&quot; /&gt;</span></a>
<a class="sourceLine" id="cb19-30" title="30"><span class="co">// =&gt; Michael.</span></a>
<a class="sourceLine" id="cb19-31" title="31"></a>
<a class="sourceLine" id="cb19-32" title="32"><span class="co">// &lt;Cowboy&gt;&lt;Greeting name=&quot;Michael&quot; /&gt;&lt;/Cowboy&gt;</span></a>
<a class="sourceLine" id="cb19-33" title="33"><span class="co">// =&gt; Howdy Michael.</span></a></code></pre>
    </div>
    <h2 id="contexttypes">contextTypes</h2>
    <div class="sourceCode" id="cb20">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb20-1" title="1">    <span class="co">// add to the context-aware component</span></a>
<a class="sourceLine" id="cb20-2" title="2">    <span class="co">// requires &#39;prop-types&#39; library</span></a>
<a class="sourceLine" id="cb20-3" title="3"></a>
<a class="sourceLine" id="cb20-4" title="4">    contextTypes<span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb20-5" title="5">      <span class="dt">color</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">string</span></a>
<a class="sourceLine" id="cb20-6" title="6">    <span class="op">},</span></a></code></pre>
    </div>
    <h2 id="childcontexttypes">childContextTypes</h2>
    <div class="sourceCode" id="cb21">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb21-1" title="1">    <span class="co">// add to the context provider</span></a>
<a class="sourceLine" id="cb21-2" title="2">    <span class="co">// requires &#39;prop-types&#39; library</span></a>
<a class="sourceLine" id="cb21-3" title="3"></a>
<a class="sourceLine" id="cb21-4" title="4">    childContextTypes<span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb21-5" title="5">      <span class="dt">color</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">string</span></a>
<a class="sourceLine" id="cb21-6" title="6">    <span class="op">},</span></a></code></pre>
    </div>
    <h2 id="getchildcontext">getChildContext</h2>
    <div class="sourceCode" id="cb22">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb22-1" title="1">    <span class="co">// add to the context provider</span></a>
<a class="sourceLine" id="cb22-2" title="2"></a>
<a class="sourceLine" id="cb22-3" title="3">    <span class="at">getChildContext</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb22-4" title="4">      <span class="cf">return</span> <span class="op">{</span><span class="dt">color</span><span class="op">:</span> <span class="st">&quot;purple&quot;</span><span class="op">};</span></a>
<a class="sourceLine" id="cb22-5" title="5">    <span class="op">}</span></a></code></pre>
    </div>
    <h2 id="components"><a href="#components">#</a>Components</h2>
    <h3 id="components-1">Components</h3>
    <div class="sourceCode" id="cb23">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb23-1" title="1"><span class="im">import</span> React <span class="im">from</span> <span class="st">&quot;react&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb23-2" title="2"><span class="im">import</span> ReactDOM <span class="im">from</span> <span class="st">&quot;react-dom&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb23-3" title="3"></a>
<a class="sourceLine" id="cb23-4" title="4"><span class="kw">class</span> Hello <span class="kw">extends</span> <span class="va">React</span>.<span class="at">Component</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb23-5" title="5">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb23-6" title="6">    <span class="cf">return</span> <span class="op">&lt;</span>div className<span class="op">=</span><span class="st">&quot;message-box&quot;</span><span class="op">&gt;</span>Hello <span class="op">{</span><span class="kw">this</span>.<span class="va">props</span>.<span class="at">name</span><span class="op">}</span>&lt;/div<span class="op">&gt;;</span></a>
<a class="sourceLine" id="cb23-7" title="7">  <span class="op">}</span></a>
<a class="sourceLine" id="cb23-8" title="8"><span class="op">}</span></a>
<a class="sourceLine" id="cb23-9" title="9"></a>
<a class="sourceLine" id="cb23-10" title="10"><span class="kw">const</span> el <span class="op">=</span> <span class="va">document</span>.<span class="at">body</span><span class="op">;</span></a>
<a class="sourceLine" id="cb23-11" title="11"><span class="va">ReactDOM</span>.<span class="at">render</span>(<span class="op">&lt;</span>Hello name<span class="op">=</span><span class="st">&quot;John&quot;</span> /&gt;<span class="op">,</span> el)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      Use the
      <a href="https://jsfiddle.net/reactjs/69z2wepo/">React.js jsfiddle</a> to
      start hacking. (or the unofficial
      <a href="http://jsbin.com/yafixat/edit?js,output">jsbin</a>)
    </p>
    <h3 id="import-multiple-exports">Import multiple exports</h3>
    <div class="sourceCode" id="cb24">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb24-1" title="1">    <span class="im">import</span> React<span class="op">,</span> <span class="op">{</span>Component<span class="op">}</span> <span class="im">from</span> <span class="st">&#39;react&#39;</span></a>
<a class="sourceLine" id="cb24-2" title="2">    <span class="im">import</span> ReactDOM <span class="im">from</span> <span class="st">&#39;react-dom&#39;</span></a>
<a class="sourceLine" id="cb24-3" title="3"></a>
<a class="sourceLine" id="cb24-4" title="4"></a>
<a class="sourceLine" id="cb24-5" title="5">    <span class="kw">class</span> Hello <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb24-6" title="6">      ...</a>
<a class="sourceLine" id="cb24-7" title="7">    <span class="op">}</span></a></code></pre>
    </div>
    <h3 id="properties">Properties</h3>
    <div class="sourceCode" id="cb25">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb25-1" title="1">    <span class="op">&lt;</span>Video fullscreen<span class="op">={</span><span class="kw">true</span><span class="op">}</span> autoplay<span class="op">={</span><span class="kw">false</span><span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb25-2" title="2"></a>
<a class="sourceLine" id="cb25-3" title="3"></a>
<a class="sourceLine" id="cb25-4" title="4">    <span class="at">render</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb25-5" title="5">      <span class="kw">this</span>.<span class="va">props</span>.<span class="at">fullscreen</span></a>
<a class="sourceLine" id="cb25-6" title="6">      <span class="kw">const</span> <span class="op">{</span> fullscreen<span class="op">,</span> autoplay <span class="op">}</span> <span class="op">=</span> <span class="kw">this</span>.<span class="at">props</span></a>
<a class="sourceLine" id="cb25-7" title="7">      ···</a>
<a class="sourceLine" id="cb25-8" title="8">    <span class="op">}</span></a></code></pre>
    </div>
    <p>
      Use <code>this.props</code> to access properties passed to the component.
    </p>
    <p>
      See:
      <a href="https://reactjs.org/docs/tutorial.html#using-props"
        >Properties</a
      >
    </p>
    <h3 id="states">States</h3>
    <div class="sourceCode" id="cb26">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb26-1" title="1">    <span class="at">constructor</span>(props) <span class="op">{</span></a>
<a class="sourceLine" id="cb26-2" title="2">      <span class="kw">super</span>(props)</a>
<a class="sourceLine" id="cb26-3" title="3">      <span class="kw">this</span>.<span class="at">state</span> <span class="op">=</span> <span class="op">{</span> <span class="dt">username</span><span class="op">:</span> <span class="kw">undefined</span> <span class="op">}</span></a>
<a class="sourceLine" id="cb26-4" title="4">    <span class="op">}</span></a>
<a class="sourceLine" id="cb26-5" title="5"></a>
<a class="sourceLine" id="cb26-6" title="6"></a>
<a class="sourceLine" id="cb26-7" title="7">    <span class="kw">this</span>.<span class="at">setState</span>(<span class="op">{</span> <span class="dt">username</span><span class="op">:</span> <span class="st">&#39;rstacruz&#39;</span> <span class="op">}</span>)</a>
<a class="sourceLine" id="cb26-8" title="8"></a>
<a class="sourceLine" id="cb26-9" title="9"></a>
<a class="sourceLine" id="cb26-10" title="10">    <span class="at">render</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb26-11" title="11">      <span class="kw">this</span>.<span class="va">state</span>.<span class="at">username</span></a>
<a class="sourceLine" id="cb26-12" title="12">      <span class="kw">const</span> <span class="op">{</span> username <span class="op">}</span> <span class="op">=</span> <span class="kw">this</span>.<span class="at">state</span></a>
<a class="sourceLine" id="cb26-13" title="13">      ···</a>
<a class="sourceLine" id="cb26-14" title="14">    <span class="op">}</span></a></code></pre>
    </div>
    <p>Use states (<code>this.state</code>) to manage dynamic data.</p>
    <p>
      With <a href="https://babeljs.io/">Babel</a> you can use
      <a href="https://github.com/tc39/proposal-class-fields"
        >proposal-class-fields</a
      >
      and get rid of constructor
    </p>
    <div class="sourceCode" id="cb27">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb27-1" title="1">    <span class="kw">class</span> Hello <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb27-2" title="2">      state <span class="op">=</span> <span class="op">{</span> <span class="dt">username</span><span class="op">:</span> <span class="kw">undefined</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb27-3" title="3">      ...</a>
<a class="sourceLine" id="cb27-4" title="4">    <span class="op">}</span></a></code></pre>
    </div>
    <p>
      See:
      <a href="https://reactjs.org/docs/tutorial.html#reactive-state">States</a>
    </p>
    <h3 id="nesting">Nesting</h3>
    <div class="sourceCode" id="cb28">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb28-1" title="1"><span class="kw">class</span> Info <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb28-2" title="2">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb28-3" title="3">    <span class="kw">const</span> <span class="op">{</span> avatar<span class="op">,</span> username <span class="op">}</span> <span class="op">=</span> <span class="kw">this</span>.<span class="at">props</span><span class="op">;</span></a>
<a class="sourceLine" id="cb28-4" title="4"></a>
<a class="sourceLine" id="cb28-5" title="5">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb28-6" title="6">      <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb28-7" title="7">        <span class="op">&lt;</span>UserAvatar src<span class="op">={</span>avatar<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb28-8" title="8">        <span class="op">&lt;</span>UserProfile username<span class="op">={</span>username<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb28-9" title="9">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb28-10" title="10">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb28-11" title="11">  <span class="op">}</span></a>
<a class="sourceLine" id="cb28-12" title="12"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      As of React v16.2.0, fragments can be used to return multiple children
      without adding extra wrapping nodes to the DOM.
    </p>
    <div class="sourceCode" id="cb29">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb29-1" title="1"><span class="im">import</span> React<span class="op">,</span> <span class="op">{</span> Component<span class="op">,</span> Fragment <span class="op">}</span> <span class="im">from</span> <span class="st">&quot;react&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb29-2" title="2"></a>
<a class="sourceLine" id="cb29-3" title="3"><span class="kw">class</span> Info <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb29-4" title="4">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb29-5" title="5">    <span class="kw">const</span> <span class="op">{</span> avatar<span class="op">,</span> username <span class="op">}</span> <span class="op">=</span> <span class="kw">this</span>.<span class="at">props</span><span class="op">;</span></a>
<a class="sourceLine" id="cb29-6" title="6"></a>
<a class="sourceLine" id="cb29-7" title="7">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb29-8" title="8">      <span class="op">&lt;</span>Fragment<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb29-9" title="9">        <span class="op">&lt;</span>UserAvatar src<span class="op">={</span>avatar<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb29-10" title="10">        <span class="op">&lt;</span>UserProfile username<span class="op">={</span>username<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb29-11" title="11">      &lt;/Fragment<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb29-12" title="12">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb29-13" title="13">  <span class="op">}</span></a>
<a class="sourceLine" id="cb29-14" title="14"><span class="op">}</span></a></code></pre>
    </div>
    <p>Nest components to separate concerns.</p>
    <p>
      See:
      <a
        href="https://reactjs.org/docs/components-and-props.html#composing-components"
        >Composing Components</a
      >
    </p>
    <h3 id="children">Children</h3>
    <div class="sourceCode" id="cb30">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb30-1" title="1"><span class="op">&lt;</span>AlertBox<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb30-2" title="2">  <span class="op">&lt;</span>h1<span class="op">&gt;</span>You have pending notifications&lt;/h1<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb30-3" title="3">&lt;/AlertBox<span class="op">&gt;;</span></a>
<a class="sourceLine" id="cb30-4" title="4"></a>
<a class="sourceLine" id="cb30-5" title="5"><span class="kw">class</span> AlertBox <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb30-6" title="6">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb30-7" title="7">    <span class="cf">return</span> <span class="op">&lt;</span>div className<span class="op">=</span><span class="st">&quot;alert-box&quot;</span><span class="op">&gt;{</span><span class="kw">this</span>.<span class="va">props</span>.<span class="at">children</span><span class="op">}</span>&lt;/div<span class="op">&gt;;</span></a>
<a class="sourceLine" id="cb30-8" title="8">  <span class="op">}</span></a>
<a class="sourceLine" id="cb30-9" title="9"><span class="op">}</span></a></code></pre>
    </div>
    <p>Children are passed as the <code>children</code> property.</p>
    <h2 id="defaults"><a href="#defaults">#</a>Defaults</h2>
    <h3 id="setting-default-props">Setting default props</h3>
    <div class="sourceCode" id="cb31">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb31-1" title="1"><span class="va">Hello</span>.<span class="at">defaultProps</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb31-2" title="2">  <span class="dt">color</span><span class="op">:</span> <span class="st">&quot;blue&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb31-3" title="3"><span class="op">};</span></a></code></pre>
    </div>
    <p>
      See:
      <a href="https://reactjs.org/docs/react-component.html#defaultprops"
        >defaultProps</a
      >
    </p>
    <h3 id="setting-default-state">Setting default state</h3>
    <div class="sourceCode" id="cb32">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb32-1" title="1"><span class="kw">class</span> Hello <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb32-2" title="2">  <span class="at">constructor</span>(props) <span class="op">{</span></a>
<a class="sourceLine" id="cb32-3" title="3">    <span class="kw">super</span>(props)<span class="op">;</span></a>
<a class="sourceLine" id="cb32-4" title="4">    <span class="kw">this</span>.<span class="at">state</span> <span class="op">=</span> <span class="op">{</span> <span class="dt">visible</span><span class="op">:</span> <span class="kw">true</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb32-5" title="5">  <span class="op">}</span></a>
<a class="sourceLine" id="cb32-6" title="6"><span class="op">}</span></a></code></pre>
    </div>
    <p>Set the default state in the <code>constructor()</code>.</p>
    <p>
      And without constructor using <a href="https://babeljs.io/">Babel</a> with
      <a href="https://github.com/tc39/proposal-class-fields"
        >proposal-class-fields</a
      >.
    </p>
    <div class="sourceCode" id="cb33">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb33-1" title="1"><span class="kw">class</span> Hello <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb33-2" title="2">  state <span class="op">=</span> <span class="op">{</span> <span class="dt">visible</span><span class="op">:</span> <span class="kw">true</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb33-3" title="3"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      See:
      <a
        href="https://reactjs.org/docs/react-without-es6.html#setting-the-initial-state"
        >Setting the default state</a
      >
    </p>
    <h2 id="other-components">
      <a href="#other-components">#</a>Other components
    </h2>
    <h3 id="functional-components">Functional components</h3>
    <div class="sourceCode" id="cb34">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb34-1" title="1"><span class="kw">function</span> <span class="at">MyComponent</span>(<span class="op">{</span> name <span class="op">}</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb34-2" title="2">  <span class="cf">return</span> <span class="op">&lt;</span>div className<span class="op">=</span><span class="st">&quot;message-box&quot;</span><span class="op">&gt;</span>Hello <span class="op">{</span>name<span class="op">}</span>&lt;/div<span class="op">&gt;;</span></a>
<a class="sourceLine" id="cb34-3" title="3"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      Functional components have no state. Also, their <code>props</code> are
      passed as the first parameter to a function.
    </p>
    <p>
      See:
      <a
        href="https://reactjs.org/docs/components-and-props.html#functional-and-class-components"
        >Function and Class Components</a
      >
    </p>
    <h3 id="pure-components">Pure components</h3>
    <div class="sourceCode" id="cb35">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb35-1" title="1">    <span class="im">import</span> React<span class="op">,</span> <span class="op">{</span>PureComponent<span class="op">}</span> <span class="im">from</span> <span class="st">&#39;react&#39;</span></a>
<a class="sourceLine" id="cb35-2" title="2"></a>
<a class="sourceLine" id="cb35-3" title="3">    <span class="kw">class</span> MessageBox <span class="kw">extends</span> PureComponent <span class="op">{</span></a>
<a class="sourceLine" id="cb35-4" title="4">      ···</a>
<a class="sourceLine" id="cb35-5" title="5">    <span class="op">}</span></a></code></pre>
    </div>
    <p>
      Performance-optimized version of <code>React.Component</code>. Doesn’t
      rerender if props/state hasn’t changed.
    </p>
    <p>
      See:
      <a href="https://reactjs.org/docs/react-api.html#react.purecomponent"
        >Pure components</a
      >
    </p>
    <h3 id="component-api">Component API</h3>
    <div class="sourceCode" id="cb36">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb36-1" title="1">    <span class="kw">this</span>.<span class="at">forceUpdate</span>()</a>
<a class="sourceLine" id="cb36-2" title="2"></a>
<a class="sourceLine" id="cb36-3" title="3"></a>
<a class="sourceLine" id="cb36-4" title="4">    <span class="kw">this</span>.<span class="at">setState</span>(<span class="op">{</span> ... <span class="op">}</span>)</a>
<a class="sourceLine" id="cb36-5" title="5">    <span class="kw">this</span>.<span class="at">setState</span>(state <span class="kw">=&gt;</span> <span class="op">{</span> ... <span class="op">}</span>)</a>
<a class="sourceLine" id="cb36-6" title="6"></a>
<a class="sourceLine" id="cb36-7" title="7"></a>
<a class="sourceLine" id="cb36-8" title="8">    <span class="kw">this</span>.<span class="at">state</span></a>
<a class="sourceLine" id="cb36-9" title="9">    <span class="kw">this</span>.<span class="at">props</span></a></code></pre>
    </div>
    <p>
      These methods and properties are available for
      <code>Component</code> instances.
    </p>
    <p>
      See:
      <a href="https://facebook.github.io/react/docs/component-api.html"
        >Component API</a
      >
    </p>
    <h2 id="lifecycle"><a href="#lifecycle">#</a>Lifecycle</h2>
    <h3 id="mounting">Mounting</h3>
    <table>
      <thead>
        <tr class="header">
          <th>Method</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>constructor</code> <em>(props)</em></td>
          <td>
            Before rendering
            <a href="https://reactjs.org/docs/react-component.html#constructor"
              >#</a
            >
          </td>
        </tr>
        <tr class="even">
          <td><code>componentWillMount()</code></td>
          <td>
            <em>Don’t use this</em>
            <a
              href="https://reactjs.org/docs/react-component.html#componentwillmount"
              >#</a
            >
          </td>
        </tr>
        <tr class="odd">
          <td><code>render()</code></td>
          <td>
            Render
            <a href="https://reactjs.org/docs/react-component.html#render">#</a>
          </td>
        </tr>
        <tr class="even">
          <td><code>componentDidMount()</code></td>
          <td>
            After rendering (DOM available)
            <a
              href="https://reactjs.org/docs/react-component.html#componentdidmount"
              >#</a
            >
          </td>
        </tr>
        <tr class="odd">
          <td><code>componentWillUnmount()</code></td>
          <td>
            Before DOM removal
            <a
              href="https://reactjs.org/docs/react-component.html#componentwillunmount"
              >#</a
            >
          </td>
        </tr>
        <tr class="even">
          <td><code>componentDidCatch()</code></td>
          <td>
            Catch errors (16+)
            <a
              href="https://reactjs.org/blog/2017/07/26/error-handling-in-react-16.html"
              >#</a
            >
          </td>
        </tr>
      </tbody>
    </table>
    <p>
      Set initial the state on <code>constructor()</code>. Add DOM event
      handlers, timers (etc) on <code>componentDidMount()</code>, then remove
      them on <code>componentWillUnmount()</code>.
    </p>
    <h3 id="updating">Updating</h3>
    <table>
      <colgroup>
        <col style="width: 51%" />
        <col style="width: 48%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Method</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td>
            <code>componentDidUpdate</code>
            <em>(prevProps, prevState, snapshot)</em>
          </td>
          <td>
            Use <code>setState()</code> here, but remember to compare props
          </td>
        </tr>
        <tr class="even">
          <td>
            <code>shouldComponentUpdate</code> <em>(newProps, newState)</em>
          </td>
          <td>Skips <code>render()</code> if returns false</td>
        </tr>
        <tr class="odd">
          <td><code>render()</code></td>
          <td>Render</td>
        </tr>
        <tr class="even">
          <td>
            <code>componentDidUpdate</code> <em>(prevProps, prevState)</em>
          </td>
          <td>Operate on the DOM here</td>
        </tr>
      </tbody>
    </table>
    <p>
      Called when parents change properties and <code>.setState()</code>. These
      are not called for initial renders.
    </p>
    <p>
      See:
      <a
        href="https://facebook.github.io/react/docs/component-specs.html#updating-componentwillreceiveprops"
        >Component specs</a
      >
    </p>
    <h2 id="hooks-new"><a href="#hooks-new">#</a>Hooks (New)</h2>
    <h3 id="state-hook">State Hook</h3>
    <div class="sourceCode" id="cb37">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb37-1" title="1"><span class="im">import</span> React<span class="op">,</span> <span class="op">{</span> useState <span class="op">}</span> <span class="im">from</span> <span class="st">&quot;react&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb37-2" title="2"></a>
<a class="sourceLine" id="cb37-3" title="3"><span class="kw">function</span> <span class="at">Example</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb37-4" title="4">  <span class="kw">const</span> [count<span class="op">,</span> setCount] <span class="op">=</span> <span class="at">useState</span>(<span class="dv">0</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb37-5" title="5"></a>
<a class="sourceLine" id="cb37-6" title="6">  <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb37-7" title="7">    <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb37-8" title="8">      <span class="op">&lt;</span>p<span class="op">&gt;</span>You clicked <span class="op">{</span>count<span class="op">}</span> times&lt;/p<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb37-9" title="9">      <span class="op">&lt;</span>button onClick<span class="op">={</span>() <span class="kw">=&gt;</span> <span class="at">setCount</span>(count <span class="op">+</span> <span class="dv">1</span>)<span class="op">}&gt;</span>Click me&lt;/button<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb37-10" title="10">    &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb37-11" title="11">  )<span class="op">;</span></a>
<a class="sourceLine" id="cb37-12" title="12"><span class="op">}</span></a></code></pre>
    </div>
    <p>Hooks are a new addition in React 16.8.</p>
    <p>
      See:
      <a href="https://reactjs.org/docs/hooks-overview.html"
        >Hooks at a Glance</a
      >
    </p>
    <h3 id="declaring-multiple-state-variables">
      Declaring multiple state variables
    </h3>
    <div class="sourceCode" id="cb38">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb38-1" title="1"><span class="kw">function</span> <span class="at">ExampleWithManyStates</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb38-2" title="2">  <span class="kw">const</span> [age<span class="op">,</span> setAge] <span class="op">=</span> <span class="at">useState</span>(<span class="dv">42</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb38-3" title="3">  <span class="kw">const</span> [fruit<span class="op">,</span> setFruit] <span class="op">=</span> <span class="at">useState</span>(<span class="st">&quot;banana&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb38-4" title="4">  <span class="kw">const</span> [todos<span class="op">,</span> setTodos] <span class="op">=</span> <span class="at">useState</span>([<span class="op">{</span> <span class="dt">text</span><span class="op">:</span> <span class="st">&quot;Learn Hooks&quot;</span> <span class="op">}</span>])<span class="op">;</span></a>
<a class="sourceLine" id="cb38-5" title="5"><span class="op">}</span></a></code></pre>
    </div>
    <h3 id="effect-hook">Effect hook</h3>
    <div class="sourceCode" id="cb39">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb39-1" title="1"><span class="im">import</span> React<span class="op">,</span> <span class="op">{</span> useState<span class="op">,</span> useEffect <span class="op">}</span> <span class="im">from</span> <span class="st">&quot;react&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb39-2" title="2"></a>
<a class="sourceLine" id="cb39-3" title="3"><span class="kw">function</span> <span class="at">Example</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb39-4" title="4">  <span class="kw">const</span> [count<span class="op">,</span> setCount] <span class="op">=</span> <span class="at">useState</span>(<span class="dv">0</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb39-5" title="5"></a>
<a class="sourceLine" id="cb39-6" title="6">  <span class="at">useEffect</span>(() <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb39-7" title="7">    <span class="va">document</span>.<span class="at">title</span> <span class="op">=</span> <span class="vs">`You clicked </span><span class="sc">${</span>count<span class="sc">}</span><span class="vs"> times`</span><span class="op">;</span></a>
<a class="sourceLine" id="cb39-8" title="8">  <span class="op">},</span> [count])<span class="op">;</span></a>
<a class="sourceLine" id="cb39-9" title="9"></a>
<a class="sourceLine" id="cb39-10" title="10">  <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb39-11" title="11">    <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb39-12" title="12">      <span class="op">&lt;</span>p<span class="op">&gt;</span>You clicked <span class="op">{</span>count<span class="op">}</span> times&lt;/p<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb39-13" title="13">      <span class="op">&lt;</span>button onClick<span class="op">={</span>() <span class="kw">=&gt;</span> <span class="at">setCount</span>(count <span class="op">+</span> <span class="dv">1</span>)<span class="op">}&gt;</span>Click me&lt;/button<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb39-14" title="14">    &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb39-15" title="15">  )<span class="op">;</span></a>
<a class="sourceLine" id="cb39-16" title="16"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      If you’re familiar with React class lifecycle methods, you can think of
      <code>useEffect</code> Hook as <code>componentDidMount</code>,
      <code>componentDidUpdate</code>, and
      <code>componentWillUnmount</code> combined.
    </p>
    <p>
      By default, React runs the effects after every render — including the
      first render.
    </p>
    <h3 id="building-your-own-hooks">Building your own hooks</h3>
    <h4 id="define-friendstatus">Define FriendStatus</h4>
    <div class="sourceCode" id="cb40">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb40-1" title="1"><span class="im">import</span> React<span class="op">,</span> <span class="op">{</span> useState<span class="op">,</span> useEffect <span class="op">}</span> <span class="im">from</span> <span class="st">&quot;react&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb40-2" title="2"></a>
<a class="sourceLine" id="cb40-3" title="3"><span class="kw">function</span> <span class="at">FriendStatus</span>(props) <span class="op">{</span></a>
<a class="sourceLine" id="cb40-4" title="4">  <span class="kw">const</span> [isOnline<span class="op">,</span> setIsOnline] <span class="op">=</span> <span class="at">useState</span>(<span class="kw">null</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb40-5" title="5"></a>
<a class="sourceLine" id="cb40-6" title="6">  <span class="at">useEffect</span>(() <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb40-7" title="7">    <span class="kw">function</span> <span class="at">handleStatusChange</span>(status) <span class="op">{</span></a>
<a class="sourceLine" id="cb40-8" title="8">      <span class="at">setIsOnline</span>(<span class="va">status</span>.<span class="at">isOnline</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb40-9" title="9">    <span class="op">}</span></a>
<a class="sourceLine" id="cb40-10" title="10"></a>
<a class="sourceLine" id="cb40-11" title="11">    <span class="va">ChatAPI</span>.<span class="at">subscribeToFriendStatus</span>(<span class="va">props</span>.<span class="va">friend</span>.<span class="at">id</span><span class="op">,</span> handleStatusChange)<span class="op">;</span></a>
<a class="sourceLine" id="cb40-12" title="12">    <span class="cf">return</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb40-13" title="13">      <span class="va">ChatAPI</span>.<span class="at">unsubscribeFromFriendStatus</span>(<span class="va">props</span>.<span class="va">friend</span>.<span class="at">id</span><span class="op">,</span> handleStatusChange)<span class="op">;</span></a>
<a class="sourceLine" id="cb40-14" title="14">    <span class="op">};</span></a>
<a class="sourceLine" id="cb40-15" title="15">  <span class="op">},</span> [<span class="va">props</span>.<span class="va">friend</span>.<span class="at">id</span>])<span class="op">;</span></a>
<a class="sourceLine" id="cb40-16" title="16"></a>
<a class="sourceLine" id="cb40-17" title="17">  <span class="cf">if</span> (isOnline <span class="op">===</span> <span class="kw">null</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb40-18" title="18">    <span class="cf">return</span> <span class="st">&quot;Loading...&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb40-19" title="19">  <span class="op">}</span></a>
<a class="sourceLine" id="cb40-20" title="20">  <span class="cf">return</span> isOnline <span class="op">?</span> <span class="st">&quot;Online&quot;</span> : <span class="st">&quot;Offline&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb40-21" title="21"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      Effects may also optionally specify how to “clean up” after them by
      returning a function.
    </p>
    <h4 id="use-friendstatus">Use FriendStatus</h4>
    <div class="sourceCode" id="cb41">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb41-1" title="1"><span class="kw">function</span> <span class="at">FriendStatus</span>(props) <span class="op">{</span></a>
<a class="sourceLine" id="cb41-2" title="2">  <span class="kw">const</span> isOnline <span class="op">=</span> <span class="at">useFriendStatus</span>(<span class="va">props</span>.<span class="va">friend</span>.<span class="at">id</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb41-3" title="3"></a>
<a class="sourceLine" id="cb41-4" title="4">  <span class="cf">if</span> (isOnline <span class="op">===</span> <span class="kw">null</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb41-5" title="5">    <span class="cf">return</span> <span class="st">&quot;Loading...&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb41-6" title="6">  <span class="op">}</span></a>
<a class="sourceLine" id="cb41-7" title="7">  <span class="cf">return</span> isOnline <span class="op">?</span> <span class="st">&quot;Online&quot;</span> : <span class="st">&quot;Offline&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb41-8" title="8"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      See:
      <a href="https://reactjs.org/docs/hooks-custom.html"
        >Building Your Own Hooks</a
      >
    </p>
    <h3 id="hooks-api-reference">Hooks API Reference</h3>
    <p>
      Also see: <a href="https://reactjs.org/docs/hooks-faq.html">Hooks FAQ</a>
    </p>
    <h4 id="basic-hooks">Basic Hooks</h4>
    <table>
      <thead>
        <tr class="header">
          <th>Hook</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>useState</code><em>(initialState)</em></td>
          <td> </td>
        </tr>
        <tr class="even">
          <td><code>useEffect</code><em>(() =&gt; { … })</em></td>
          <td> </td>
        </tr>
        <tr class="odd">
          <td><code>useContext</code><em>(MyContext)</em></td>
          <td>value returned from <code>React.createContext</code></td>
        </tr>
      </tbody>
    </table>
    <p>
      Full details:
      <a href="https://reactjs.org/docs/hooks-reference.html#basic-hooks"
        >Basic Hooks</a
      >
    </p>
    <h4 id="additional-hooks">Additional Hooks</h4>
    <table>
      <colgroup>
        <col style="width: 35%" />
        <col style="width: 64%" />
      </colgroup>
      <thead>
        <tr class="header">
          <th>Hook</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>useReducer</code><em>(reducer, initialArg, init)</em></td>
          <td> </td>
        </tr>
        <tr class="even">
          <td><code>useCallback</code><em>(() =&gt; { … })</em></td>
          <td> </td>
        </tr>
        <tr class="odd">
          <td><code>useMemo</code><em>(() =&gt; { … })</em></td>
          <td> </td>
        </tr>
        <tr class="even">
          <td><code>useRef</code><em>(initialValue)</em></td>
          <td> </td>
        </tr>
        <tr class="odd">
          <td>
            <code>useImperativeHandle</code><em>(ref, () =&gt; { … })</em>
          </td>
          <td> </td>
        </tr>
        <tr class="even">
          <td><code>useLayoutEffect</code></td>
          <td>
            identical to <code>useEffect</code>, but it fires synchronously
            after all DOM mutations
          </td>
        </tr>
        <tr class="odd">
          <td><code>useDebugValue</code><em>(value)</em></td>
          <td>display a label for custom hooks in React DevTools</td>
        </tr>
      </tbody>
    </table>
    <p>
      Full details:
      <a href="https://reactjs.org/docs/hooks-reference.html#additional-hooks"
        >Additional Hooks</a
      >
    </p>
    <h2 id="dom-nodes"><a href="#dom-nodes">#</a>DOM nodes</h2>
    <h3 id="references">References</h3>
    <div class="sourceCode" id="cb42">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb42-1" title="1"><span class="kw">class</span> MyComponent <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb42-2" title="2">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb42-3" title="3">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb42-4" title="4">      <span class="op">&lt;</span>div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb42-5" title="5">        <span class="op">&lt;</span>input ref<span class="op">={</span>(el) <span class="kw">=&gt;</span> (<span class="kw">this</span>.<span class="at">input</span> <span class="op">=</span> el)<span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb42-6" title="6">      &lt;/div<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb42-7" title="7">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb42-8" title="8">  <span class="op">}</span></a>
<a class="sourceLine" id="cb42-9" title="9"></a>
<a class="sourceLine" id="cb42-10" title="10">  <span class="at">componentDidMount</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb42-11" title="11">    <span class="kw">this</span>.<span class="va">input</span>.<span class="at">focus</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb42-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb42-13" title="13"><span class="op">}</span></a></code></pre>
    </div>
    <p>Allows access to DOM nodes.</p>
    <p>
      See:
      <a href="https://reactjs.org/docs/refs-and-the-dom.html"
        >Refs and the DOM</a
      >
    </p>
    <h3 id="dom-events">DOM Events</h3>
    <div class="sourceCode" id="cb43">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb43-1" title="1"><span class="kw">class</span> MyComponent <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb43-2" title="2">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb43-3" title="3">    <span class="op">&lt;</span>input</a>
<a class="sourceLine" id="cb43-4" title="4">      type<span class="op">=</span><span class="st">&quot;text&quot;</span></a>
<a class="sourceLine" id="cb43-5" title="5">      value<span class="op">={</span><span class="kw">this</span>.<span class="va">state</span>.<span class="at">value</span><span class="op">}</span></a>
<a class="sourceLine" id="cb43-6" title="6">      onChange<span class="op">={</span>(event) <span class="kw">=&gt;</span> <span class="kw">this</span>.<span class="at">onChange</span>(event)<span class="op">}</span></a>
<a class="sourceLine" id="cb43-7" title="7">    /&gt;<span class="op">;</span></a>
<a class="sourceLine" id="cb43-8" title="8">  <span class="op">}</span></a>
<a class="sourceLine" id="cb43-9" title="9"></a>
<a class="sourceLine" id="cb43-10" title="10">  <span class="at">onChange</span>(event) <span class="op">{</span></a>
<a class="sourceLine" id="cb43-11" title="11">    <span class="kw">this</span>.<span class="at">setState</span>(<span class="op">{</span> <span class="dt">value</span><span class="op">:</span> <span class="va">event</span>.<span class="va">target</span>.<span class="at">value</span> <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb43-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb43-13" title="13"><span class="op">}</span></a></code></pre>
    </div>
    <p>Pass functions to attributes like <code>onChange</code>.</p>
    <p>See: <a href="https://reactjs.org/docs/events.html">Events</a></p>
    <h2 id="other-features"><a href="#other-features">#</a>Other features</h2>
    <h3 id="transferring-props">Transferring props</h3>
    <div class="sourceCode" id="cb44">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb44-1" title="1"><span class="op">&lt;</span>VideoPlayer src<span class="op">=</span><span class="st">&quot;video.mp4&quot;</span> /&gt;<span class="op">;</span></a>
<a class="sourceLine" id="cb44-2" title="2"></a>
<a class="sourceLine" id="cb44-3" title="3"><span class="kw">class</span> VideoPlayer <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb44-4" title="4">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb44-5" title="5">    <span class="cf">return</span> <span class="op">&lt;</span>VideoEmbed <span class="op">{</span>...<span class="va">this</span>.<span class="at">props</span><span class="op">}</span> /&gt;<span class="op">;</span></a>
<a class="sourceLine" id="cb44-6" title="6">  <span class="op">}</span></a>
<a class="sourceLine" id="cb44-7" title="7"><span class="op">}</span></a></code></pre>
    </div>
    <p>Propagates <code>src="..."</code> down to the sub-component.</p>
    <p>
      See
      <a href="https://facebook.github.io/react/docs/transferring-props.html"
        >Transferring props</a
      >
    </p>
    <h3 id="top-level-api">Top-level API</h3>
    <div class="sourceCode" id="cb45">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb45-1" title="1">    <span class="va">React</span>.<span class="at">createClass</span>(<span class="op">{</span> ... <span class="op">}</span>)</a>
<a class="sourceLine" id="cb45-2" title="2">    <span class="va">React</span>.<span class="at">isValidElement</span>(c)</a>
<a class="sourceLine" id="cb45-3" title="3"></a>
<a class="sourceLine" id="cb45-4" title="4"></a>
<a class="sourceLine" id="cb45-5" title="5">    <span class="va">ReactDOM</span>.<span class="at">render</span>(<span class="op">&lt;</span>Component /<span class="op">&gt;,</span> domnode<span class="op">,</span> [callback])</a>
<a class="sourceLine" id="cb45-6" title="6">    <span class="va">ReactDOM</span>.<span class="at">unmountComponentAtNode</span>(domnode)</a>
<a class="sourceLine" id="cb45-7" title="7"></a>
<a class="sourceLine" id="cb45-8" title="8"></a>
<a class="sourceLine" id="cb45-9" title="9">    <span class="va">ReactDOMServer</span>.<span class="at">renderToString</span>(<span class="op">&lt;</span>Component /<span class="op">&gt;</span>)</a>
<a class="sourceLine" id="cb45-10" title="10">    <span class="va">ReactDOMServer</span>.<span class="at">renderToStaticMarkup</span>(<span class="op">&lt;</span>Component /<span class="op">&gt;</span>)</a></code></pre>
    </div>
    <p>There are more, but these are most common.</p>
    <p>
      See:
      <a href="https://reactjs.org/docs/react-api.html">React top-level API</a>
    </p>
    <h2 id="jsx-patterns"><a href="#jsx-patterns">#</a>JSX patterns</h2>
    <h3 id="style-shorthand">Style shorthand</h3>
    <div class="sourceCode" id="cb46">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb46-1" title="1"><span class="kw">const</span> style <span class="op">=</span> <span class="op">{</span> <span class="dt">height</span><span class="op">:</span> <span class="dv">10</span> <span class="op">};</span></a>
<a class="sourceLine" id="cb46-2" title="2"><span class="cf">return</span> <span class="op">&lt;</span>div style<span class="op">={</span>style<span class="op">}&gt;</span>&lt;/div<span class="op">&gt;;</span></a>
<a class="sourceLine" id="cb46-3" title="3"></a>
<a class="sourceLine" id="cb46-4" title="4"><span class="cf">return</span> <span class="op">&lt;</span>div style<span class="op">={{</span> <span class="dt">margin</span><span class="op">:</span> <span class="dv">0</span><span class="op">,</span> <span class="dt">padding</span><span class="op">:</span> <span class="dv">0</span> <span class="op">}}&gt;</span>&lt;/div<span class="op">&gt;;</span></a></code></pre>
    </div>
    <p>
      See:
      <a href="https://reactjs.org/tips/inline-styles.html">Inline styles</a>
    </p>
    <h3 id="inner-html">Inner HTML</h3>
    <div class="sourceCode" id="cb47">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb47-1" title="1"><span class="kw">function</span> <span class="at">markdownify</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb47-2" title="2">  <span class="cf">return</span> <span class="st">&quot;&lt;p&gt;...&lt;/p&gt;&quot;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb47-3" title="3"><span class="op">}</span></a>
<a class="sourceLine" id="cb47-4" title="4"><span class="op">&lt;</span>div dangerouslySetInnerHTML<span class="op">={{</span> <span class="dt">__html</span><span class="op">:</span> <span class="at">markdownify</span>() <span class="op">}}</span> /&gt;<span class="op">;</span></a></code></pre>
    </div>
    <p>
      See:
      <a href="https://reactjs.org/tips/dangerously-set-inner-html.html"
        >Dangerously set innerHTML</a
      >
    </p>
    <h3 id="lists">Lists</h3>
    <div class="sourceCode" id="cb48">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb48-1" title="1"><span class="kw">class</span> TodoList <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb48-2" title="2">  <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb48-3" title="3">    <span class="kw">const</span> <span class="op">{</span> items <span class="op">}</span> <span class="op">=</span> <span class="kw">this</span>.<span class="at">props</span><span class="op">;</span></a>
<a class="sourceLine" id="cb48-4" title="4"></a>
<a class="sourceLine" id="cb48-5" title="5">    <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb48-6" title="6">      <span class="op">&lt;</span>ul<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb48-7" title="7">        <span class="op">{</span><span class="va">items</span>.<span class="at">map</span>((item) <span class="kw">=&gt;</span> (</a>
<a class="sourceLine" id="cb48-8" title="8">          <span class="op">&lt;</span>TodoItem item<span class="op">={</span>item<span class="op">}</span> key<span class="op">={</span><span class="va">item</span>.<span class="at">key</span><span class="op">}</span> /&gt;</a>
<a class="sourceLine" id="cb48-9" title="9">        ))<span class="op">}</span></a>
<a class="sourceLine" id="cb48-10" title="10">      &lt;/ul<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb48-11" title="11">    )<span class="op">;</span></a>
<a class="sourceLine" id="cb48-12" title="12">  <span class="op">}</span></a>
<a class="sourceLine" id="cb48-13" title="13"><span class="op">}</span></a></code></pre>
    </div>
    <p>Always supply a <code>key</code> property.</p>
    <h3 id="conditionals">Conditionals</h3>
    <div class="sourceCode" id="cb49">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb49-1" title="1"><span class="op">&lt;</span>Fragment<span class="op">&gt;{</span>showMyComponent <span class="op">?</span> <span class="op">&lt;</span>MyComponent /<span class="op">&gt;</span> : <span class="op">&lt;</span>OtherComponent /<span class="op">&gt;}</span>&lt;/Fragment<span class="op">&gt;</span></a></code></pre>
    </div>
    <h3 id="short-circuit-evaluation">Short-circuit evaluation</h3>
    <div class="sourceCode" id="cb50">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb50-1" title="1"><span class="op">&lt;</span>Fragment<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb50-2" title="2">  <span class="op">{</span>showPopup <span class="op">&amp;&amp;</span> <span class="op">&lt;</span>Popup /<span class="op">&gt;}</span></a>
<a class="sourceLine" id="cb50-3" title="3">  ...</a>
<a class="sourceLine" id="cb50-4" title="4">&lt;/Fragment<span class="op">&gt;</span></a></code></pre>
    </div>
    <h2 id="new-features"><a href="#new-features">#</a>New features</h2>
    <h3 id="returning-multiple-elements">Returning multiple elements</h3>
    <p>You can return multiple elements as arrays or fragments.</p>
    <h4 id="arrays">Arrays</h4>
    <div class="sourceCode" id="cb51">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb51-1" title="1">    <span class="at">render</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb51-2" title="2"></a>
<a class="sourceLine" id="cb51-3" title="3">      <span class="cf">return</span> [</a>
<a class="sourceLine" id="cb51-4" title="4">        <span class="op">&lt;</span>li key<span class="op">=</span><span class="st">&quot;A&quot;</span><span class="op">&gt;</span>First item&lt;/li<span class="op">&gt;,</span></a>
<a class="sourceLine" id="cb51-5" title="5">        <span class="op">&lt;</span>li key<span class="op">=</span><span class="st">&quot;B&quot;</span><span class="op">&gt;</span>Second item&lt;/li<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb51-6" title="6">      ]</a>
<a class="sourceLine" id="cb51-7" title="7">    <span class="op">}</span></a></code></pre>
    </div>
    <h4 id="fragments">Fragments</h4>
    <div class="sourceCode" id="cb52">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb52-1" title="1">    <span class="at">render</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb52-2" title="2"></a>
<a class="sourceLine" id="cb52-3" title="3">      <span class="cf">return</span> (</a>
<a class="sourceLine" id="cb52-4" title="4">        <span class="op">&lt;</span>Fragment<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb52-5" title="5">          <span class="op">&lt;</span>li<span class="op">&gt;</span>First item&lt;/li<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb52-6" title="6">          <span class="op">&lt;</span>li<span class="op">&gt;</span>Second item&lt;/li<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb52-7" title="7">        &lt;/Fragment<span class="op">&gt;</span></a>
<a class="sourceLine" id="cb52-8" title="8">      )</a>
<a class="sourceLine" id="cb52-9" title="9">    <span class="op">}</span></a></code></pre>
    </div>
    <p>
      See:
      <a
        href="https://reactjs.org/blog/2017/09/26/react-v16.0.html#new-render-return-types-fragments-and-strings"
        >Fragments and strings</a
      >
    </p>
    <h3 id="returning-strings">Returning strings</h3>
    <div class="sourceCode" id="cb53">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb53-1" title="1">    <span class="at">render</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb53-2" title="2">      <span class="cf">return</span> <span class="st">&#39;Look ma, no spans!&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb53-3" title="3">    <span class="op">}</span></a></code></pre>
    </div>
    <p>You can return just a string.</p>
    <p>
      See:
      <a
        href="https://reactjs.org/blog/2017/09/26/react-v16.0.html#new-render-return-types-fragments-and-strings"
        >Fragments and strings</a
      >
    </p>
    <h3 id="errors">Errors</h3>
    <div class="sourceCode" id="cb54">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb54-1" title="1">    <span class="kw">class</span> MyComponent <span class="kw">extends</span> Component <span class="op">{</span></a>
<a class="sourceLine" id="cb54-2" title="2">      ···</a>
<a class="sourceLine" id="cb54-3" title="3">      <span class="at">componentDidCatch</span> (error<span class="op">,</span> info) <span class="op">{</span></a>
<a class="sourceLine" id="cb54-4" title="4">        <span class="kw">this</span>.<span class="at">setState</span>(<span class="op">{</span> error <span class="op">}</span>)</a>
<a class="sourceLine" id="cb54-5" title="5">      <span class="op">}</span></a>
<a class="sourceLine" id="cb54-6" title="6">    <span class="op">}</span></a></code></pre>
    </div>
    <p>Catch errors via <code>componentDidCatch</code>. (React 16+)</p>
    <p>
      See:
      <a
        href="https://reactjs.org/blog/2017/07/26/error-handling-in-react-16.html"
        >Error handling in React 16</a
      >
    </p>
    <h3 id="portals">Portals</h3>
    <div class="sourceCode" id="cb55">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb55-1" title="1">    <span class="at">render</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb55-2" title="2">      <span class="cf">return</span> <span class="va">React</span>.<span class="at">createPortal</span>(</a>
<a class="sourceLine" id="cb55-3" title="3">        <span class="kw">this</span>.<span class="va">props</span>.<span class="at">children</span><span class="op">,</span></a>
<a class="sourceLine" id="cb55-4" title="4">        <span class="va">document</span>.<span class="at">getElementById</span>(<span class="st">&#39;menu&#39;</span>)</a>
<a class="sourceLine" id="cb55-5" title="5">      )</a>
<a class="sourceLine" id="cb55-6" title="6">    <span class="op">}</span></a></code></pre>
    </div>
    <p>
      This renders <code>this.props.children</code> into any location in the
      DOM.
    </p>
    <p>See: <a href="https://reactjs.org/docs/portals.html">Portals</a></p>
    <h3 id="hydration">Hydration</h3>
    <div class="sourceCode" id="cb56">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb56-1" title="1"><span class="kw">const</span> el <span class="op">=</span> <span class="va">document</span>.<span class="at">getElementById</span>(<span class="st">&quot;app&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb56-2" title="2"><span class="va">ReactDOM</span>.<span class="at">hydrate</span>(<span class="op">&lt;</span>App /<span class="op">&gt;,</span> el)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      Use <code>ReactDOM.hydrate</code> instead of using
      <code>ReactDOM.render</code> if you’re rendering over the output of
      <a href="https://reactjs.org/docs/react-dom-server.html">ReactDOMServer</a
      >.
    </p>
    <p>
      See: <a href="https://reactjs.org/docs/react-dom.html#hydrate">Hydrate</a>
    </p>
    <h2 id="property-validation">
      <a href="#property-validation">#</a>Property validation
    </h2>
    <h3 id="proptypes">PropTypes</h3>
    <div class="sourceCode" id="cb57">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb57-1" title="1"><span class="im">import</span> PropTypes <span class="im">from</span> <span class="st">&quot;prop-types&quot;</span><span class="op">;</span></a></code></pre>
    </div>
    <p>
      See:
      <a href="https://reactjs.org/docs/typechecking-with-proptypes.html"
        >Typechecking with PropTypes</a
      >
    </p>
    <table>
      <thead>
        <tr class="header">
          <th>Key</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>any</code></td>
          <td>Anything</td>
        </tr>
      </tbody>
    </table>
    <h4 id="basic">Basic</h4>
    <table>
      <thead>
        <tr class="header">
          <th>Key</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>string</code></td>
          <td> </td>
        </tr>
        <tr class="even">
          <td><code>number</code></td>
          <td> </td>
        </tr>
        <tr class="odd">
          <td><code>func</code></td>
          <td>Function</td>
        </tr>
        <tr class="even">
          <td><code>bool</code></td>
          <td>True or false</td>
        </tr>
      </tbody>
    </table>
    <h4 id="enum">Enum</h4>
    <table>
      <thead>
        <tr class="header">
          <th>Key</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>oneOf</code><em>(any)</em></td>
          <td>Enum types</td>
        </tr>
        <tr class="even">
          <td><code>oneOfType</code><em>(type array)</em></td>
          <td>Union</td>
        </tr>
      </tbody>
    </table>
    <h4 id="array">Array</h4>
    <table>
      <thead>
        <tr class="header">
          <th>Key</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>array</code></td>
          <td> </td>
        </tr>
        <tr class="even">
          <td><code>arrayOf</code><em>(…)</em></td>
          <td> </td>
        </tr>
      </tbody>
    </table>
    <h4 id="object">Object</h4>
    <table>
      <thead>
        <tr class="header">
          <th>Key</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>object</code></td>
          <td> </td>
        </tr>
        <tr class="even">
          <td><code>objectOf</code><em>(…)</em></td>
          <td>Object with values of a certain type</td>
        </tr>
        <tr class="odd">
          <td><code>instanceOf</code><em>(…)</em></td>
          <td>Instance of a class</td>
        </tr>
        <tr class="even">
          <td><code>shape</code><em>(…)</em></td>
          <td> </td>
        </tr>
      </tbody>
    </table>
    <h4 id="elements">Elements</h4>
    <table>
      <thead>
        <tr class="header">
          <th>Key</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>element</code></td>
          <td>React element</td>
        </tr>
        <tr class="even">
          <td><code>node</code></td>
          <td>DOM node</td>
        </tr>
      </tbody>
    </table>
    <h4 id="required">Required</h4>
    <table>
      <thead>
        <tr class="header">
          <th>Key</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>(···).isRequired</code></td>
          <td>Required</td>
        </tr>
      </tbody>
    </table>
    <h3 id="basic-types">Basic types</h3>
    <div class="sourceCode" id="cb58">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb58-1" title="1"><span class="va">MyComponent</span>.<span class="at">propTypes</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb58-2" title="2">  <span class="dt">email</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">string</span><span class="op">,</span></a>
<a class="sourceLine" id="cb58-3" title="3">  <span class="dt">seats</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">number</span><span class="op">,</span></a>
<a class="sourceLine" id="cb58-4" title="4">  <span class="dt">callback</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">func</span><span class="op">,</span></a>
<a class="sourceLine" id="cb58-5" title="5">  <span class="dt">isClosed</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">bool</span><span class="op">,</span></a>
<a class="sourceLine" id="cb58-6" title="6">  <span class="dt">any</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">any</span><span class="op">,</span></a>
<a class="sourceLine" id="cb58-7" title="7"><span class="op">};</span></a></code></pre>
    </div>
    <h3 id="required-types">Required types</h3>
    <div class="sourceCode" id="cb59">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb59-1" title="1"><span class="va">MyCo</span>.<span class="at">propTypes</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb59-2" title="2">  <span class="dt">name</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="va">string</span>.<span class="at">isRequired</span><span class="op">,</span></a>
<a class="sourceLine" id="cb59-3" title="3"><span class="op">};</span></a></code></pre>
    </div>
    <h3 id="elements-1">Elements</h3>
    <div class="sourceCode" id="cb60">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb60-1" title="1"><span class="va">MyCo</span>.<span class="at">propTypes</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb60-2" title="2">  <span class="dt">element</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">element</span><span class="op">,</span></a>
<a class="sourceLine" id="cb60-3" title="3"></a>
<a class="sourceLine" id="cb60-4" title="4">  <span class="dt">node</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">node</span><span class="op">,</span></a>
<a class="sourceLine" id="cb60-5" title="5"><span class="op">};</span></a></code></pre>
    </div>
    <h3 id="enumerables-oneof">Enumerables (oneOf)</h3>
    <div class="sourceCode" id="cb61">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb61-1" title="1"><span class="va">MyCo</span>.<span class="at">propTypes</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb61-2" title="2">  <span class="dt">direction</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">oneOf</span>([<span class="st">&quot;left&quot;</span><span class="op">,</span> <span class="st">&quot;right&quot;</span>])<span class="op">,</span></a>
<a class="sourceLine" id="cb61-3" title="3"><span class="op">};</span></a></code></pre>
    </div>
    <h3 id="arrays-and-objects">Arrays and objects</h3>
    <div class="sourceCode" id="cb62">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb62-1" title="1"><span class="va">MyCo</span>.<span class="at">propTypes</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb62-2" title="2">  <span class="dt">list</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">array</span><span class="op">,</span></a>
<a class="sourceLine" id="cb62-3" title="3">  <span class="dt">ages</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">arrayOf</span>(<span class="va">PropTypes</span>.<span class="at">number</span>)<span class="op">,</span></a>
<a class="sourceLine" id="cb62-4" title="4">  <span class="dt">user</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">object</span><span class="op">,</span></a>
<a class="sourceLine" id="cb62-5" title="5">  <span class="dt">user</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">objectOf</span>(<span class="va">PropTypes</span>.<span class="at">number</span>)<span class="op">,</span></a>
<a class="sourceLine" id="cb62-6" title="6">  <span class="dt">message</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">instanceOf</span>(Message)<span class="op">,</span></a>
<a class="sourceLine" id="cb62-7" title="7"><span class="op">};</span></a>
<a class="sourceLine" id="cb62-8" title="8"></a>
<a class="sourceLine" id="cb62-9" title="9"><span class="va">MyCo</span>.<span class="at">propTypes</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb62-10" title="10">  <span class="dt">user</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">shape</span>(<span class="op">{</span></a>
<a class="sourceLine" id="cb62-11" title="11">    <span class="dt">name</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">string</span><span class="op">,</span></a>
<a class="sourceLine" id="cb62-12" title="12">    <span class="dt">age</span><span class="op">:</span> <span class="va">PropTypes</span>.<span class="at">number</span><span class="op">,</span></a>
<a class="sourceLine" id="cb62-13" title="13">  <span class="op">}</span>)<span class="op">,</span></a>
<a class="sourceLine" id="cb62-14" title="14"><span class="op">};</span></a></code></pre>
    </div>
    <p>
      Use <code>.array[Of]</code>, <code>.object[Of]</code>,
      <code>.instanceOf</code>, <code>.shape</code>.
    </p>
    <h3 id="custom-validation">Custom validation</h3>
    <div class="sourceCode" id="cb63">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb63-1" title="1"><span class="va">MyCo</span>.<span class="at">propTypes</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb63-2" title="2">  <span class="dt">customProp</span><span class="op">:</span> (props<span class="op">,</span> key<span class="op">,</span> componentName) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb63-3" title="3">    <span class="cf">if</span> (<span class="op">!</span><span class="ss">/matchme/</span>.<span class="at">test</span>(props[key])) <span class="op">{</span></a>
<a class="sourceLine" id="cb63-4" title="4">      <span class="cf">return</span> <span class="kw">new</span> <span class="at">Error</span>(<span class="st">&quot;Validation failed!&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb63-5" title="5">    <span class="op">}</span></a>
<a class="sourceLine" id="cb63-6" title="6">  <span class="op">},</span></a>
<a class="sourceLine" id="cb63-7" title="7"><span class="op">};</span></a></code></pre>
    </div>
  </body>
</html>
